﻿#region copyright
//Copyright 2013 Ramon Ordiales Plaza
//
//This file is part of FastMessage.
//
//    FastMessage is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    FastMessage is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with FastMessage.  If not, see <http://www.gnu.org/licenses/>.
//
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FastMessage
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length < 3)
            {
                ShowHelp();
                return;
            }
            var mensaje = new Message(args[0], args[1], args[2]);
            if (string.IsNullOrWhiteSpace(mensaje.Origen) || (string.IsNullOrWhiteSpace(mensaje.Destino)))
            {
                ShowHelp();
                return;
            }
            FastMessageLib.SendMessage(mensaje);
            return;
        }

        private static void ShowHelp()
        {
            Console.WriteLine("FastMessage origen destino \"mensaje\"");
            
        }
    }
}
