;--------------------------------
;Include Modern UI

  !include "MUI2.nsh"

;--------------------------------
;General

;--------------------------------
; The name of the installer
Name "TrayFastMsg"
; The file to write
OutFile "TrayFastMsgSetup.exe"
; The default installation directory
InstallDir $PROGRAMFILES\EEZA\FastMessages

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\EEZA\FastMessages" "Install_Dir"

; Request application privileges for Windows Vista
RequestExecutionLevel admin

;--------------------------------

; Pages

  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES

;--------------------------------

; First is default

!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "English"

; The stuff to install
Section "TrayFastMsg"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File "..\Compilacion\FastMessage.exe"
  File "..\Compilacion\TrayFastMsg.exe"
    
  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\EEZA\FastMessages" "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FastMessages" "DisplayName" "TrayFastMsg"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FastMessages" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FastMessages" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FastMessages" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\EEZA\TrayFastMsg"
  CreateShortCut "$SMPROGRAMS\EEZA\TrayFastMsg\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\EEZA\TrayFastMsg\TrayFastMsg.lnk" "$INSTDIR\TrayFastMsg.exe" "" "$INSTDIR\TrayFastMsg.exe" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\FastMessages"
  DeleteRegKey HKLM SOFTWARE\EEZA\FastMessages

  ; Remove files and uninstaller
  Delete $INSTDIR\TrayFastMsg.exe
  Delete $INSTDIR\FastMessages.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\EEZA\TrayFastMsg\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\EEZA\TrayFastMsg"
  RMDir "$INSTDIR"

SectionEnd
